﻿EnableExplicit

;- -- Information.
; Dieses Modul ist das Hauptfenster des Projekts.

;- -- Version 01.
; Status:   In Arbeit.
; Autor:    Peter Dreisiebner
; E-Mail:   web@dreisiebner.at
; Website:  http://peter.dreisiebner.at
; Geändert: 2017-10-22 - PureBasic v5.61 (x86).


;-
;- -- DeclareModule WindowStart. --------------------
;
DeclareModule WindowStartXml
   EnableExplicit

   Declare.i Open()

EndDeclareModule  ; WindowStartXml.

;
;- -- Include.
;

;-
;- -- Module WindowStartXml. --------------------
;
Module WindowStartXml
   EnableExplicit
   UseModule Common
   UseModule Macros
   UseModule Tool
   DebugOutWindowStartXml
   
   ;-
   ;- -- Konstanten.
   #iWindowWidth = 800
   #iWindowHeight = 450
   #iWindowMinWidth = 150
   #iWindowMinHeight = 150
   CompilerIf #fDebugOut Or #fDebugError Or #fDebugSpeed Or #fDebugInfo Or #fDebugSuccess Or #fDebugTemp
      #sWindowTitle = #sApplicationName + " (Debugversion)"
   CompilerElse
      #sWindowTitle = #sApplicationName
   CompilerEndIf

   #sFontName = "Courier New"
   #iFontSize = 9

   #sMenuTitleFile = "&Datei"
   #sMenuItemFileExit = "&Beenden"
   #sMenuTitleEdit = "&Bearbeiten"
   #sMenuTitleHelp = "&Hilfe"
   #sMenuItemHelpLog = "&Log..."
   #sMenuItemHelpAbout = "&Über..."
   Enumeration eMenuItemId
      #eMenuItemFileExit
      #eMenuItemHelpLog
      #eMenuItemHelpAbout
   EndEnumeration

   Enumeration eDialogId 1 ; Nicht mit Null beginnen, ansonst wird das Programm gleich wieder beendet.
      #eWindow             ; Das Fenster bzw. der Dialog darf nicht die ID Null haben.
      #eSplitter
      #eListView
      #eEditor
   EndEnumeration

   Enumeration
      #iListViewEmpty
      #iListViewGetVersion
      #iListViewUsbTmcGetDeviceList
      #iListViewUsbTmcOwnContext
      #iListViewRigolScreencopy
      #iListViewUsbTmcNewInstance
      #iListViewUsbTmcSetTmcDevice
      #iListViewUsbTmcSendData
      #iListViewUsbTmcRequestData
      #iListViewUsbTmcSendRequestThreadData
      #iListViewUsbTmcSendDataSRE16
      #iListViewUsbTmcSendDataSRE0
      #iListViewUsbTmcSendWaitRequestThreadData
      #iListViewUsbTmcSendDataIDN
      #iListViewUsbTmcRequestDataOnly
      #iListViewUsbTmcSendRequestThreadDataMemoryDump
      #iListViewUsbTmcSendDataVendorSpecific
      #iListViewUsbTmcSendRequestDataVendorSpecific
      #iListViewUsbTmcSendDataError
      #iListViewUsbTmcInitiateAbortBulkOut
      #iListViewUsbTmcCheckAbortBulkOutStatus
      #iListViewUsbTmcInitiateAbortBulkIn
      #iListViewUsbTmcCheckAbortBulkInStatus
      #iListViewUsbTmcInitiateClear
      #iListViewUsbTmcCheckClearStatus
      #iListViewUsbTmcGetCapabilities
      #iListViewUsbTmcIndicatorPulse
      #iListViewUsbTmcReadStatusByte
      #iListViewUsbTmcInterruptTransfer
      #iListViewUsbTmcRemoteEnableControl
      #iListViewUsbTmcLocalLockout
      #iListViewUsbTmcGoToLocal
      #iListViewUsbTmcDeleteInstance
   EndEnumeration
   
   ;-
   ;- -- Variablen.
   Global miWindowNumber.i
   Global miWindowDialogNumber.i
   Global miWindowXmlNumber.i
   Global miMenuNumber.i
   Global miListViewGadgetNumber.i
   Global miEditorGadgetNumber.i
   Global miSplitterGadgetNumber.i

   Global miUsbTmc.i
   ; Für das Testfenster der Bildschirmkopien, damit die Kommunikation abgebrochen werden kann beim Beenden des Programms.
   Global NewList mWindowScreencopyList.i()
   
   ;-
   ;- -- Declares.
   Declare LibUsbGetVersion()
   Declare Close()
   Declare UsbTmcGetDeviceList()
   Declare UsbTmcOwnContext()
   Declare UsbTmcRigolScreencopy()
   Declare UsbTmcNewInstance()
   Declare UsbTmcSetTmcDevice()
   Declare UsbTmcSendData(sScpi.s)
   Declare UsbTmcRequestData(sScpi.s)
   Declare UsbTmcSendRequestThreadData(fWaitSRE.i = #False)
   Declare UsbTmcSendRequestThreadDataMemoryDump()
   Declare UsbTmcSendDataVendorSpecific()
   Declare UsbTmcSendRequestDataVendorSpecific(sScpi.s)
   Declare UsbTmcSendDataError()
   Declare UsbTmcReadStatusByte()
   Declare UsbTmcInterruptTransfer()
   Declare UsbTmcInitiateAbortBulkOut()
   Declare UsbTmcInitiateAbortBulkIn()
   Declare UsbTmcCheckAbortBulkOutStatus()
   Declare UsbTmcCheckAbortBulkInStatus()
   Declare UsbTmcInitiateClear()
   Declare UsbTmcCheckClearStatus()
   Declare UsbTmcGetCapabilities()
   Declare UsbTmcIndicatorPulse()
   Declare UsbTmcRemoteEnableControl()
   Declare UsbTmcLocalLockout()
   Declare UsbTmcGoToLocal()
   Declare UsbTmcDeleteInstance()

   ;-

   Procedure.i EventCloseWindow()
      ; Ereignisprozedur wenn das Fenster geschlossen werden soll.
      DebugView::ProcIn()

      Close()

      DebugView::ProcOut()
   EndProcedure


   Procedure EventMinimizeWindow()
      DebugView::ProcIn()

      WindowLog::Hide()

      DebugView::ProcOut()
   EndProcedure


   Procedure EventRestoreWindow()
      DebugView::ProcIn()

      WindowLog::RestoreWindow()

      DebugView::ProcOut()
   EndProcedure


   Procedure EventMenuFileExit()
      DebugView::ProcIn()

      Close()

      DebugView::ProcOut()
   EndProcedure


   Procedure EventMenuHelpLog()
      DebugView::ProcIn()

      WindowLog::Show(miWindowNumber)

      DebugView::ProcOut()
   EndProcedure


   Procedure EventMenuHelpAbout()
      DebugView::ProcIn()

      WindowAbout::Open(miWindowNumber)

      DebugView::ProcOut()
   EndProcedure


   Procedure EventListViewGadgetLeftClick()
      ; Ereignis wenn ein Eintrag in dem ListViewGadget ausgewählt wurde.
      DebugView::ProcIn()
      Protected iItem.i, iData.i

      iItem = GetGadgetState(miListViewGadgetNumber)
      iData = GetGadgetItemData(miListViewGadgetNumber, iItem)
      Select iData
         Case #iListViewGetVersion
            LibUsbGetVersion()
         Case #iListViewUsbTmcGetDeviceList
            UsbTmcGetDeviceList()
         Case #iListViewEmpty
            ;
         Case #iListViewUsbTmcOwnContext
            UsbTmcOwnContext()
         Case #iListViewRigolScreencopy
            UsbTmcRigolScreencopy()
         Case #iListViewEmpty
            ;
         Case #iListViewUsbTmcNewInstance
            UsbTmcNewInstance()
         Case #iListViewUsbTmcSetTmcDevice
            UsbTmcSetTmcDevice()
         Case #iListViewUsbTmcSendData
            UsbTmcSendData(":ROUTe:OPEN:ALL")
         Case #iListViewUsbTmcRequestData
            UsbTmcRequestData("*IDN?")
         Case #iListViewUsbTmcSendRequestThreadData
            UsbTmcSendRequestThreadData()
         Case #iListViewUsbTmcSendDataSRE16
            UsbTmcSendData("*SRE 16")
         Case #iListViewUsbTmcSendDataSRE0
            UsbTmcSendData("*SRE 0")
         Case #iListViewUsbTmcSendWaitRequestThreadData
            UsbTmcSendRequestThreadData(#True)  ; für *SRE 16 und Interrupt-In Transfer.
         Case #iListViewUsbTmcSendDataIDN
            UsbTmcSendData("*IDN?")
         Case #iListViewUsbTmcRequestDataOnly
            UsbTmcRequestData(#Empty$)
         Case #iListViewUsbTmcSendRequestThreadDataMemoryDump
            UsbTmcSendRequestThreadDataMemoryDump()
         Case #iListViewUsbTmcSendDataVendorSpecific
            UsbTmcSendDataVendorSpecific()
         Case #iListViewUsbTmcSendRequestDataVendorSpecific
            UsbTmcSendRequestDataVendorSpecific(":SETUP:MANU?")
         Case #iListViewUsbTmcSendDataError
            UsbTmcSendDataError()
         Case #iListViewUsbTmcInitiateAbortBulkOut
            UsbTmcInitiateAbortBulkOut()
         Case #iListViewUsbTmcCheckAbortBulkOutStatus
            UsbTmcCheckAbortBulkOutStatus()
         Case #iListViewUsbTmcInitiateAbortBulkIn
            UsbTmcInitiateAbortBulkIn()
         Case #iListViewUsbTmcCheckAbortBulkInStatus
            UsbTmcCheckAbortBulkInStatus()
         Case #iListViewUsbTmcInitiateClear
            UsbTmcInitiateClear()
         Case #iListViewUsbTmcCheckClearStatus
            UsbTmcCheckClearStatus()
         Case #iListViewUsbTmcGetCapabilities
            UsbTmcGetCapabilities()
         Case #iListViewUsbTmcIndicatorPulse
            UsbTmcIndicatorPulse()
         Case #iListViewUsbTmcReadStatusByte
            UsbTmcReadStatusByte()
         Case #iListViewUsbTmcInterruptTransfer
            UsbTmcInterruptTransfer()
         Case #iListViewUsbTmcRemoteEnableControl
            UsbTmcRemoteEnableControl()
         Case #iListViewUsbTmcLocalLockout
            UsbTmcLocalLockout()
         Case #iListViewUsbTmcGoToLocal
            UsbTmcGoToLocal()
         Case #iListViewUsbTmcDeleteInstance
            UsbTmcDeleteInstance()
      EndSelect

      DebugView::ProcOut()
   EndProcedure

   ;-

   Procedure LibUsbGetVersion()
      DebugView::ProcIn()
      Protected fResult.i
      Protected sVersion.String, sDescription.String, sError.String

      ClearGadgetItems(miEditorGadgetNumber)

      If LibUsb::GetVersion(sVersion, sDescription, sError)
         AddGadgetItem(miEditorGadgetNumber, -1, "Version: " + sVersion\s)
         AddGadgetItem(miEditorGadgetNumber, -1, "Beschreibung: " + sDescription\s)
      Else
         AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
      EndIf

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcGetDeviceList()
      DebugView::ProcIn()
      Protected *uDevice.UsbTmc::uDevice, iUsbTmc.i, c.i, iDeviceCount, sError.String
      Protected uCapabilities.UsbTmc::uCapabilities
      NewList TmcDeviceList.UsbTmc::uDevice()

      ClearGadgetItems(miEditorGadgetNumber)

      iUsbTmc = UsbTmc::NewInstance(#Null, sError)
      If (Not iUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, sError\s)

      Else
         If UsbTmc::GetTmcDeviceList(iUsbTmc, TmcDeviceList(), @iDeviceCount, sError)
            If iDeviceCount
               ForEach TmcDeviceList()
                  c + 1
                  *uDevice = TmcDeviceList()
                  If *uDevice
                     If (c > 1)
                        AddGadgetItem(miEditorGadgetNumber, -1, #Null$)
                        AddGadgetItem(miEditorGadgetNumber, -1, "------------------------------------------------------------")
                     EndIf
                     AddGadgetItem(miEditorGadgetNumber, -1, "Gerät " + c)
                     AddGadgetItem(miEditorGadgetNumber, -1, "  UsbTmc: " + StringBool(*uDevice\fUsbTmc))
                     AddGadgetItem(miEditorGadgetNumber, -1, "  VendorID: $" + Hex(*uDevice\iVendorId))
                     AddGadgetItem(miEditorGadgetNumber, -1, "  ProductID: $" + Hex(*uDevice\iProductId))
                     AddGadgetItem(miEditorGadgetNumber, -1, "  Manufacturer: " + *uDevice\sManufacturer)
                     AddGadgetItem(miEditorGadgetNumber, -1, "  Product: " + *uDevice\sProduct)
                     AddGadgetItem(miEditorGadgetNumber, -1, "  Serialnumber: " + *uDevice\sSerialnumber)
                     AddGadgetItem(miEditorGadgetNumber, -1, "  BusNumber: " + *uDevice\iBusNumber)
                     AddGadgetItem(miEditorGadgetNumber, -1, "  PortNumber: " + *uDevice\iPortNumber)
                     AddGadgetItem(miEditorGadgetNumber, -1, "  ConfigurationValue: " + *uDevice\iConfigurationValue)
                     AddGadgetItem(miEditorGadgetNumber, -1, "  InterfaceNumber: " + *uDevice\iInterfaceNumber)
                     AddGadgetItem(miEditorGadgetNumber, -1, "  EndpointBulkOut: $" + Hex(*uDevice\iEndpointBulkOut))
                     AddGadgetItem(miEditorGadgetNumber, -1, "  EndpointBulkIn: $" + Hex(*uDevice\iEndpointBulkIn))
                     AddGadgetItem(miEditorGadgetNumber, -1, "  EndpointInterruptIn: $" + Hex(*uDevice\iEndpointInterruptIn))
                     AddGadgetItem(miEditorGadgetNumber, -1, #Null$)

                     AddGadgetItem(miEditorGadgetNumber, -1, "Gerät " + c + " - USBTMC-USB488-Capabilities")
                     If UsbTmc::SetTmcDevice(iUsbTmc, *uDevice, sError)
                        If (Not UsbTmc::GetCapabilities(iUsbTmc, @uCapabilities, sError))
                           AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
                           WindowLog::Error(sError\s)

                        Else
                           AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC BCD Version Number: $" + Hex(uCapabilities\iTmcBcdVersionNumber))
                           AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC Interface accepts the Indicator Pulse request: " + Tool::StringBool(uCapabilities\fTmcInterfaceAcceptsIndicatorPulseRequest))
                           AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC Interface is talk-only: " + StringBool(uCapabilities\fTmcInterfaceIsTalkOnly))
                           AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC Interface is listen-only: " + StringBool(uCapabilities\fTmcInterfaceIsListenOnly))
                           AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC Device supports ending TermChar: " + StringBool(uCapabilities\fTmcDeviceSupportsEndingTermChar))
                           AddGadgetItem(miEditorGadgetNumber, -1, #Null$)
                           AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 BCD Version Number: $" + Hex(uCapabilities\i488BcdVersionNumber))
                           AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 Interface is a 488.2 USB488 Interface: " + StringBool(uCapabilities\f488InterfaceIs4882))
                           AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 Interface accepts Remote/Local control: " + StringBool(uCapabilities\f488InterfaceAcceptsRemoteLocalControlRequests))
                           AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 Interface accepts Trigger messages: " + StringBool(uCapabilities\f488InterfaceAcceptsTriggerMessage))
                           AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 Device understands all mandatory SCPI commands: " + StringBool(uCapabilities\f488DeviceUnderstandsAllMandatoryScpiCommands))
                           AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 Device is Service Request capable: " + StringBool(uCapabilities\f488DeviceIsServiceRequestCapable))
                           AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 Device is Remote/Local capable: " + StringBool(uCapabilities\f488DeviceIsRemoteLocalCapable))
                           AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 Device is Trigger capable: " + StringBool(uCapabilities\f488DeviceIsTriggerCapable))
                        EndIf
                     Else
                        AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
                     EndIf
                  EndIf
               Next  ; ForEach.

            Else
               AddGadgetItem(miEditorGadgetNumber, -1, "Keine Geräte gefunden.")
            EndIf
         Else
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
         EndIf

         If (Not UsbTmc::DeleteInstance(iUsbTmc, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
         EndIf
      EndIf

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcOwnContext()
      DebugView::ProcIn()
      Protected *Context, *uDevice.UsbTmc::uDevice, iUsbTmc.i, c.i, iDeviceCount, sError.String
      Protected uCapabilities.UsbTmc::uCapabilities
      NewList TmcDeviceList.UsbTmc::uDevice()

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not LibUsb::Init(@*Context, sError))
         AddGadgetItem(miEditorGadgetNumber, -1, sError\s)

      Else
         AddGadgetItem(miEditorGadgetNumber, -1, "*Context: $" + Hex(*Context))
         AddGadgetItem(miEditorGadgetNumber, -1, #Null$)

         iUsbTmc = UsbTmc::NewInstance(*Context, sError)
         If (Not iUsbTmc)
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)

         Else
            If UsbTmc::GetTmcDeviceList(iUsbTmc, TmcDeviceList(), @iDeviceCount, sError)
               If iDeviceCount
                  ForEach TmcDeviceList()
                     c + 1
                     *uDevice = TmcDeviceList()
                     If *uDevice
                        If (c > 1)
                           AddGadgetItem(miEditorGadgetNumber, -1, #Null$)
                           AddGadgetItem(miEditorGadgetNumber, -1, "------------------------------------------------------------")
                        EndIf
                        AddGadgetItem(miEditorGadgetNumber, -1, "Gerät " + c)
                        AddGadgetItem(miEditorGadgetNumber, -1, "  UsbTmc: " + StringBool(*uDevice\fUsbTmc))
                        AddGadgetItem(miEditorGadgetNumber, -1, "  VendorID: $" + Hex(*uDevice\iVendorId))
                        AddGadgetItem(miEditorGadgetNumber, -1, "  ProductID: $" + Hex(*uDevice\iProductId))
                        AddGadgetItem(miEditorGadgetNumber, -1, "  Manufacturer: " + *uDevice\sManufacturer)
                        AddGadgetItem(miEditorGadgetNumber, -1, "  Product: " + *uDevice\sProduct)
                        AddGadgetItem(miEditorGadgetNumber, -1, "  Serialnumber: " + *uDevice\sSerialnumber)
                        AddGadgetItem(miEditorGadgetNumber, -1, "  BusNumber: " + *uDevice\iBusNumber)
                        AddGadgetItem(miEditorGadgetNumber, -1, "  PortNumber: " + *uDevice\iPortNumber)
                        AddGadgetItem(miEditorGadgetNumber, -1, "  ConfigurationValue: " + *uDevice\iConfigurationValue)
                        AddGadgetItem(miEditorGadgetNumber, -1, "  InterfaceNumber: " + *uDevice\iInterfaceNumber)
                        AddGadgetItem(miEditorGadgetNumber, -1, "  EndpointBulkOut: $" + Hex(*uDevice\iEndpointBulkOut))
                        AddGadgetItem(miEditorGadgetNumber, -1, "  EndpointBulkIn: $" + Hex(*uDevice\iEndpointBulkIn))
                        AddGadgetItem(miEditorGadgetNumber, -1, "  EndpointInterruptIn: $" + Hex(*uDevice\iEndpointInterruptIn))
                        AddGadgetItem(miEditorGadgetNumber, -1, #Null$)

                        AddGadgetItem(miEditorGadgetNumber, -1, "Gerät " + c + " - USBTMC-USB488-Capabilities")
                        If UsbTmc::SetTmcDevice(iUsbTmc, *uDevice, sError)
                           If (Not UsbTmc::GetCapabilities(iUsbTmc, @uCapabilities, sError))
                              AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
                              WindowLog::Error(sError\s)

                           Else
                              AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC BCD Version Number: $" + Hex(uCapabilities\iTmcBcdVersionNumber))
                              AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC Interface accepts the Indicator Pulse request: " + Tool::StringBool(uCapabilities\fTmcInterfaceAcceptsIndicatorPulseRequest))
                              AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC Interface is talk-only: " + StringBool(uCapabilities\fTmcInterfaceIsTalkOnly))
                              AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC Interface is listen-only: " + StringBool(uCapabilities\fTmcInterfaceIsListenOnly))
                              AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC Device supports ending TermChar: " + StringBool(uCapabilities\fTmcDeviceSupportsEndingTermChar))
                              AddGadgetItem(miEditorGadgetNumber, -1, #Null$)
                              AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 BCD Version Number: $" + Hex(uCapabilities\i488BcdVersionNumber))
                              AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 Interface is a 488.2 USB488 Interface: " + StringBool(uCapabilities\f488InterfaceIs4882))
                              AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 Interface accepts Remote/Local control: " + StringBool(uCapabilities\f488InterfaceAcceptsRemoteLocalControlRequests))
                              AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 Interface accepts Trigger messages: " + StringBool(uCapabilities\f488InterfaceAcceptsTriggerMessage))
                              AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 Device understands all mandatory SCPI commands: " + StringBool(uCapabilities\f488DeviceUnderstandsAllMandatoryScpiCommands))
                              AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 Device is Service Request capable: " + StringBool(uCapabilities\f488DeviceIsServiceRequestCapable))
                              AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 Device is Remote/Local capable: " + StringBool(uCapabilities\f488DeviceIsRemoteLocalCapable))
                              AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 Device is Trigger capable: " + StringBool(uCapabilities\f488DeviceIsTriggerCapable))
                           EndIf
                        Else
                           AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
                        EndIf
                     EndIf
                  Next  ; ForEach.

               Else
                  AddGadgetItem(miEditorGadgetNumber, -1, "Keine Geräte gefunden.")
               EndIf
            Else
               AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
            EndIf

            If (Not UsbTmc::DeleteInstance(iUsbTmc, sError))
               AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
            EndIf
         EndIf
      EndIf

      If *Context
         LibUsb::Exit(*Context)
      EndIf

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcRigolScreencopy()
      DebugView::ProcIn()
      Protected iWindowNumber.i
      Protected sVersion.String, sDescription.String, sError.String
      
      ClearGadgetItems(miEditorGadgetNumber)
      
      AddGadgetItem(miEditorGadgetNumber, -1, "Testfenster für die Bildschirmkopie der Rigolgeräte.")
      AddGadgetItem(miEditorGadgetNumber, -1, "Fehler werden im Log-Fenster ausgegeben.")
      AddGadgetItem(miEditorGadgetNumber, -1, #Null$)
      
      iWindowNumber = WindowScreencopy::Open()
      If (Not iWindowNumber)
         AddGadgetItem(miEditorGadgetNumber, -1, "Das Fenster konnte nicht geöffnet werden.")
      Else
         AddElement(mWindowScreencopyList())
         mWindowScreencopyList() = iWindowNumber
      EndIf
         
      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcNewInstance()
      DebugView::ProcIn()
      Protected sError.String

      ClearGadgetItems(miEditorGadgetNumber)

      If miUsbTmc
         If (Not UsbTmc::DeleteInstance(miUsbTmc, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, "vorherige UsbTmc-Instanz konnte nicht gelöscht werden: " + miUsbTmc)
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
         Else
            miUsbTmc = #Null
         EndIf
      EndIf

      miUsbTmc = UsbTmc::NewInstance(#Null, sError)
      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
      Else
         AddGadgetItem(miEditorGadgetNumber, -1, "Neue UsbTmc-Instanz erstellt: " + miUsbTmc)
      EndIf

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcSetTmcDevice()
      DebugView::ProcIn()
      Protected iDeviceCount, sError.String
      Protected uCapabilities.UsbTmc::uCapabilities
      NewList TmcDeviceList.UsbTmc::uDevice()

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, "Keine UsbTmc-Instanz vorhanden.")

      Else
         If (Not UsbTmc::GetTmcDeviceList(miUsbTmc, TmcDeviceList(), @iDeviceCount, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)

         Else
            If (Not FirstElement(TmcDeviceList()))
               AddGadgetItem(miEditorGadgetNumber, -1, "Keine Geräte gefunden.")

            Else
               With TmcDeviceList()
                  AddGadgetItem(miEditorGadgetNumber, -1, "UsbTmc-Gerät")
                  AddGadgetItem(miEditorGadgetNumber, -1, "  UsbTmc: " + StringBool(\fUsbTmc))
                  AddGadgetItem(miEditorGadgetNumber, -1, "  VendorID: $" + Hex(\iVendorId))
                  AddGadgetItem(miEditorGadgetNumber, -1, "  ProductID: $" + Hex(\iProductId))
                  AddGadgetItem(miEditorGadgetNumber, -1, "  Manufacturer: " + \sManufacturer)
                  AddGadgetItem(miEditorGadgetNumber, -1, "  Product: " + \sProduct)
                  AddGadgetItem(miEditorGadgetNumber, -1, "  Serialnumber: " + \sSerialnumber)
                  AddGadgetItem(miEditorGadgetNumber, -1, "  BusNumber: " + \iBusNumber)
                  AddGadgetItem(miEditorGadgetNumber, -1, "  PortNumber: " + \iPortNumber)
                  AddGadgetItem(miEditorGadgetNumber, -1, "  ConfigurationValue: " + \iConfigurationValue)
                  AddGadgetItem(miEditorGadgetNumber, -1, "  InterfaceNumber: " + \iInterfaceNumber)
                  AddGadgetItem(miEditorGadgetNumber, -1, "  EndpointBulkOut: $" + Hex(\iEndpointBulkOut))
                  AddGadgetItem(miEditorGadgetNumber, -1, "  EndpointBulkIn: $" + Hex(\iEndpointBulkIn))
                  AddGadgetItem(miEditorGadgetNumber, -1, "  EndpointInterruptIn: $" + Hex(\iEndpointInterruptIn))
                  AddGadgetItem(miEditorGadgetNumber, -1, "")
               EndWith

               If (Not UsbTmc::SetTmcDevice(miUsbTmc, TmcDeviceList(), sError))
                  AddGadgetItem(miEditorGadgetNumber, -1, sError\s)

               Else
                  If (Not UsbTmc::GetCapabilities(miUsbTmc, @uCapabilities, sError))
                     AddGadgetItem(miEditorGadgetNumber, -1, sError\s)

                  Else
                     With uCapabilities
                        AddGadgetItem(miEditorGadgetNumber, -1, "USBTMC-USB488-Capabilities")
                        AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC BCD Version Number: $" + Hex(\iTmcBcdVersionNumber))
                        AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC Interface accepts the Indicator Pulse request: " + Tool::StringBool(\fTmcInterfaceAcceptsIndicatorPulseRequest))
                        AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC Interface is talk-only: " + StringBool(\fTmcInterfaceIsTalkOnly))
                        AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC Interface is listen-only: " + StringBool(\fTmcInterfaceIsListenOnly))
                        AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC Device supports ending TermChar: " + StringBool(\fTmcDeviceSupportsEndingTermChar))
                        AddGadgetItem(miEditorGadgetNumber, -1, #Null$)
                        AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 BCD Version Number: $" + Hex(\i488BcdVersionNumber))
                        AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 Interface is a 488.2 USB488 Interface: " + StringBool(\f488InterfaceIs4882))
                        AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 Interface accepts Remote/Local control: " + StringBool(\f488InterfaceAcceptsRemoteLocalControlRequests))
                        AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 Interface accepts Trigger messages: " + StringBool(\f488InterfaceAcceptsTriggerMessage))
                        AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 Device understands all mandatory SCPI commands: " + StringBool(\f488DeviceUnderstandsAllMandatoryScpiCommands))
                        AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 Device is Service Request capable: " + StringBool(\f488DeviceIsServiceRequestCapable))
                        AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 Device is Remote/Local capable: " + StringBool(\f488DeviceIsRemoteLocalCapable))
                        AddGadgetItem(miEditorGadgetNumber, -1, "  USB488 Device is Trigger capable: " + StringBool(\f488DeviceIsTriggerCapable))
                     EndWith
                  EndIf
               EndIf
            EndIf
         EndIf
      EndIf

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcSendData(sScpi.s)
      DebugView::ProcIn()
      Protected sError.String
      Protected *Data, iLength.i, iTransferred.i

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, "Keine UsbTmc-Instanz vorhanden.")

      Else
         *Data = #Null
         iLength = 0 ;MemoryStringLength(*Data, #PB_Ascii)

         If (Not UsbTmc::PrepareData(miUsbTmc, sScpi, *Data, iLength, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
            WindowLog::Error(sError\s)
         Else
            If (Not UsbTmc::SendData(miUsbTmc, UsbTmc::#eMessageIdDevDepMsgOut, @iTransferred, sError))
               AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
               WindowLog::Error(sError\s)
            Else
               AddGadgetItem(miEditorGadgetNumber, -1, "SCPI: " + sScpi)
               AddGadgetItem(miEditorGadgetNumber, -1, "Die Daten wurden erfolgreich gesendet. iTransferred = " + iTransferred)
            EndIf
         EndIf
         If *Data
            FreeMemory(*Data)
         EndIf
      EndIf ; (Not iUsbTmc)

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcRequestData(sScpi.s)
      DebugView::ProcIn()
      Protected *uDevice.UsbTmc::uDevice, c.i, iDeviceCount, sError.String
      Protected uCapabilities.UsbTmc::uCapabilities
      NewList TmcDeviceList.UsbTmc::uDevice()
      Protected fResult.i, *Data, iLength.i, iTransferred.i, *ReceivedData, sHex.s

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, "Keine UsbTmc-Instanz vorhanden.")

      Else
         If Len(sScpi)
            *Data = #Null
            iLength = 0 ;MemoryStringLength(*Data, #PB_Ascii)
   
            fResult = UsbTmc::PrepareData(miUsbTmc, sScpi, *Data, iLength, sError)
   
            If (Not fResult)
               AddGadgetItem(miEditorGadgetNumber, -1, "Fehler bei UsbTmc::PrepareData():")
               AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
               WindowLog::Error(sError\s)
            EndIf
   
            If fResult
               If (Not UsbTmc::SendData(miUsbTmc, UsbTmc::#eMessageIdDevDepMsgOut, @iTransferred, sError))
                  AddGadgetItem(miEditorGadgetNumber, -1, "Fehler bei UsbTmc::SendData():")
                  AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
                  WindowLog::Error(sError\s)
   
               Else
                  AddGadgetItem(miEditorGadgetNumber, -1, "SCPI: " + sScpi)
                  AddGadgetItem(miEditorGadgetNumber, -1, "Die Daten wurden erfolgreich gesendet. iTransferred = " + iTransferred)
               EndIf
            EndIf
            If *Data
               FreeMemory(*Data)
            EndIf
         EndIf

         ;Delay(50)

         If (Not UsbTmc::RequestData(miUsbTmc, @*ReceivedData, @iTransferred, UsbTmc::#eMessageIdRequestDevDepMsgIn, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, "Fehler bei UsbTmc::RequestData():")
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
            WindowLog::Error(sError\s)

         Else
            AddGadgetItem(miEditorGadgetNumber, -1, "Die Daten wurden erfolgreich empfangen. iTransferred = " + iTransferred)
            If *ReceivedData
               If (iTransferred > 256)
                  sHex = Tool::MemoryFormatHex(*ReceivedData, 256)
                  AddGadgetItem(miEditorGadgetNumber, -1, "Die ersten 256 Bytes:")
               Else
                  sHex = Tool::MemoryFormatHex(*ReceivedData, iTransferred)
                  AddGadgetItem(miEditorGadgetNumber, -1, "Die gesamten Daten:")
               EndIf
               AddGadgetItem(miEditorGadgetNumber, -1, sHex)
            EndIf
         EndIf
         If *ReceivedData
            FreeMemory(*ReceivedData)
         EndIf
      EndIf ; (Not iUsbTmc)

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcSendRequestThreadDataEvent()
      DebugView::ProcIn()
      Protected sError.String, sHex.s
      Protected iUsbTmc.i, iEvent.i, iEventData.i, uData.UsbTmc::uThreadData
      
      iUsbTmc = EventGadget()
      iEvent = EventType()
      iEventData = EventData()
      
     Select iEvent
         Case UsbTmc::#eThreadEventSendProgress
            AddGadgetItem(miEditorGadgetNumber, -1, "Event Send Progress. Bytes: " + iEventData)
            
         Case UsbTmc::#eThreadEventSendFinished
            AddGadgetItem(miEditorGadgetNumber, -1, "Event Send Finished.")
            If (Not UsbTmc::GetThreadData(iUsbTmc, uData, sError))
               AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
               
            Else
               AddGadgetItem(miEditorGadgetNumber, -1, "uData:")
               AddGadgetItem(miEditorGadgetNumber, -1, "  iUsbTmcInstance: " + uData\iUsbTmcInstance)
               AddGadgetItem(miEditorGadgetNumber, -1, "  sScpi: " + uData\sScpi)
               AddGadgetItem(miEditorGadgetNumber, -1, "  fSendFinished: " + StringBool(uData\fSendFinished))
               AddGadgetItem(miEditorGadgetNumber, -1, "  fSendOk: " + StringBool(uData\fSendOk))
               AddGadgetItem(miEditorGadgetNumber, -1, "  iSendTransferred: " + uData\iSendTransferred)
               AddGadgetItem(miEditorGadgetNumber, -1, "  sError: " + uData\sError)
               AddGadgetItem(miEditorGadgetNumber, -1, #Null$)
            EndIf
            
         Case UsbTmc::#eThreadEventRequestProgress
            AddGadgetItem(miEditorGadgetNumber, -1, "Event Request Progress. Bytes: " + iEventData)
            
         Case UsbTmc::#eThreadEventRequestFinished
            AddGadgetItem(miEditorGadgetNumber, -1, "Event Request Finished.")
            If (Not UsbTmc::GetThreadData(iUsbTmc, uData, sError))
               AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
               
            Else
               AddGadgetItem(miEditorGadgetNumber, -1, "uData:")
               AddGadgetItem(miEditorGadgetNumber, -1, "  iUsbTmcInstance: " + uData\iUsbTmcInstance)
               AddGadgetItem(miEditorGadgetNumber, -1, "  fRequestFinished: " + StringBool(uData\fRequestFinished))
               AddGadgetItem(miEditorGadgetNumber, -1, "  fRequestOk: " + StringBool(uData\fRequestOk))
               AddGadgetItem(miEditorGadgetNumber, -1, "  iRequestTransferred: " + uData\iRequestTransferred)
               AddGadgetItem(miEditorGadgetNumber, -1, "  sError: " + uData\sError)
               AddGadgetItem(miEditorGadgetNumber, -1, #Null$)
               
               If uData\RequestData
                  AddGadgetItem(miEditorGadgetNumber, -1, "  RequestData Length: " + MemorySize(uData\RequestData))
                  If (uData\iRequestTransferred > 256)
                     sHex = Tool::MemoryFormatHex(uData\RequestData, 256)
                     AddGadgetItem(miEditorGadgetNumber, -1, "Die ersten 256 Bytes:")
                  Else
                     sHex = Tool::MemoryFormatHex(uData\RequestData, uData\iRequestTransferred)
                     AddGadgetItem(miEditorGadgetNumber, -1, "Die gesamten Daten:")
                  EndIf
                  AddGadgetItem(miEditorGadgetNumber, -1, sHex)
                  FreeMemory(uData\RequestData)
               Else
                  AddGadgetItem(miEditorGadgetNumber, -1, "Der Zeiger auf die Daten ist Null. \RequestData = 0")
               EndIf
            EndIf
            
         Case UsbTmc::#eThreadEventThreadFinished
            UnbindEvent(UsbTmc::#eCustomEventUsbTmcThreadData, @UsbTmcSendRequestThreadDataEvent(), miWindowNumber)
            AddGadgetItem(miEditorGadgetNumber, -1, #Null$)
            AddGadgetItem(miEditorGadgetNumber, -1, "Der Thread wurde beendet.")
            
         Default
            AddGadgetItem(miEditorGadgetNumber, -1, #Null$)
            AddGadgetItem(miEditorGadgetNumber, -1, "Fehler - Ungültiges Ereignis. iEvent = " + iEvent)
      EndSelect
      
      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcSendRequestThreadData(fWaitSRE.i = #False)
      DebugView::ProcIn()
      Protected sError.String
      Protected uData.UsbTmc::uThreadData

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, "Keine UsbTmc-Instanz vorhanden.")

      Else
         If fWaitSRE
            AddGadgetItem(miEditorGadgetNumber, -1, "SendRequestThreadData - fWaitSRE")
         Else
            AddGadgetItem(miEditorGadgetNumber, -1, "SendRequestThreadData")
         EndIf
         AddGadgetItem(miEditorGadgetNumber, -1, #Null$)
         With uData
            \iUsbTmcInstance = miUsbTmc
            \iEventListenerWindowNumber = miWindowNumber
            \fSendData = #True
            \sScpi = "*IDN?"
            \SendData = #Null
            \iSendDataLength = 0
            \eSendMessageId = UsbTmc::#eMessageIdDevDepMsgOut
            \fRequestData = #True
            \RequestData = #Null
            \eRequestMessageId = UsbTmc::#eMessageIdRequestDevDepMsgIn
            \fWaitDataServiceRequest = fWaitSRE
         EndWith
         
         BindEvent(UsbTmc::#eCustomEventUsbTmcThreadData, @UsbTmcSendRequestThreadDataEvent(), miWindowNumber)

         If (Not UsbTmc::SendRequestThreadData(miUsbTmc, uData, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
            UnbindEvent(UsbTmc::#eCustomEventUsbTmcThreadData, @UsbTmcSendRequestThreadDataEvent(), miWindowNumber)
         EndIf
      EndIf ; (Not iUsbTmc)

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcSendRequestThreadDataMemoryDump()
      DebugView::ProcIn()
      Protected sError.String
      Protected uData.UsbTmc::uThreadData

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, "Keine UsbTmc-Instanz vorhanden.")

      Else
         AddGadgetItem(miEditorGadgetNumber, -1, "SendRequestThreadData")
         AddGadgetItem(miEditorGadgetNumber, -1, #Null$)
         With uData
            \iUsbTmcInstance = miUsbTmc
            \iEventListenerWindowNumber = miWindowNumber
            \fSendData = #True
            ;\sScpi = ":SYST:UTIL:READ? 1,33554432"
            \sScpi = ":SYST:UTIL:READ? 1,10000000"
            \SendData = #Null
            \iSendDataLength = 0
            \eSendMessageId = UsbTmc::#eMessageIdDevDepMsgOut
            \fRequestData = #True
            \RequestData = #Null
            \eRequestMessageId = UsbTmc::#eMessageIdRequestDevDepMsgIn
         EndWith

         BindEvent(UsbTmc::#eCustomEventUsbTmcThreadData, @UsbTmcSendRequestThreadDataEvent(), miWindowNumber)

         If (Not UsbTmc::SendRequestThreadData(miUsbTmc, uData, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
            UnbindEvent(UsbTmc::#eCustomEventUsbTmcThreadData, @UsbTmcSendRequestThreadDataEvent(), miWindowNumber)
         EndIf
      EndIf ; (Not iUsbTmc)

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcSendDataVendorSpecific()
      DebugView::ProcIn()
      Protected sError.String
      Protected sScpi.s, *Data, iLength.i, iTransferred.i

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, "Keine UsbTmc-Instanz vorhanden.")

      Else
         sScpi = ":TEST:MAXCURR"
         *Data = #Null
         iLength = 0 ;MemoryStringLength(*Data, #PB_Ascii)

         If (Not UsbTmc::PrepareData(miUsbTmc, sScpi, *Data, iLength, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
            WindowLog::Error(sError\s)
         Else
            If (Not UsbTmc::SendData(miUsbTmc, UsbTmc::#eMessageIdVendorSpecificOut, @iTransferred, sError))
               AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
               WindowLog::Error(sError\s)
            Else
               AddGadgetItem(miEditorGadgetNumber, -1, "SCPI: " + sScpi)
               AddGadgetItem(miEditorGadgetNumber, -1, "Die Daten wurden erfolgreich gesendet. iTransferred = " + iTransferred)
            EndIf
         EndIf
         If *Data
            FreeMemory(*Data)
         EndIf
      EndIf ; (Not iUsbTmc)

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcSendRequestDataVendorSpecific(sScpi.s)
      DebugView::ProcIn()
      Protected *uDevice.UsbTmc::uDevice, c.i, iDeviceCount, sError.String
      Protected uCapabilities.UsbTmc::uCapabilities
      NewList TmcDeviceList.UsbTmc::uDevice()
      Protected fResult.i, *Data, iLength.i, iTransferred.i, *ReceivedData, sHex.s

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, "Keine UsbTmc-Instanz vorhanden.")

      Else
         If Len(sScpi)
            *Data = #Null
            iLength = 0 ;MemoryStringLength(*Data, #PB_Ascii)
   
            fResult = UsbTmc::PrepareData(miUsbTmc, sScpi, *Data, iLength, sError)
   
            If (Not fResult)
               AddGadgetItem(miEditorGadgetNumber, -1, "Fehler bei UsbTmc::PrepareData():")
               AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
               WindowLog::Error(sError\s)
            EndIf
   
            If fResult
               If (Not UsbTmc::SendData(miUsbTmc, UsbTmc::#eMessageIdVendorSpecificOut, @iTransferred, sError))
                  AddGadgetItem(miEditorGadgetNumber, -1, "Fehler bei UsbTmc::SendData():")
                  AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
                  WindowLog::Error(sError\s)
   
               Else
                  AddGadgetItem(miEditorGadgetNumber, -1, "SCPI: " + sScpi)
                  AddGadgetItem(miEditorGadgetNumber, -1, "Die Daten wurden erfolgreich gesendet. iTransferred = " + iTransferred)
               EndIf
            EndIf
            If *Data
               FreeMemory(*Data)
            EndIf
         EndIf

         ;Delay(50)

         If (Not UsbTmc::RequestData(miUsbTmc, @*ReceivedData, @iTransferred, UsbTmc::#eMessageIdRequestVendorSpecificIn, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, "Fehler bei UsbTmc::RequestData():")
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
            WindowLog::Error(sError\s)

         Else
            AddGadgetItem(miEditorGadgetNumber, -1, "Die Daten wurden erfolgreich empfangen. iTransferred = " + iTransferred)
            If *ReceivedData
               If (iTransferred > 256)
                  sHex = Tool::MemoryFormatHex(*ReceivedData, 256)
                  AddGadgetItem(miEditorGadgetNumber, -1, "Die ersten 256 Bytes:")
               Else
                  sHex = Tool::MemoryFormatHex(*ReceivedData, iTransferred)
                  AddGadgetItem(miEditorGadgetNumber, -1, "Die gesamten Daten:")
               EndIf
               AddGadgetItem(miEditorGadgetNumber, -1, sHex)
            EndIf
         EndIf
         If *ReceivedData
            FreeMemory(*ReceivedData)
         EndIf
      EndIf ; (Not iUsbTmc)

      DebugView::ProcOut()
   EndProcedure
   

   Procedure UsbTmcSendDataError()
      DebugView::ProcIn()
      Protected sError.String
      Protected sScpi.s, *Data, iLength.i, iTransferred.i

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, "Keine UsbTmc-Instanz vorhanden.")

      Else
         sScpi = ":ROUTe:OPEN:ALL"
         *Data = #Null
         iLength = 0 ;MemoryStringLength(*Data, #PB_Ascii)

         If (Not UsbTmc::PrepareData(miUsbTmc, sScpi, *Data, iLength, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
            WindowLog::Error(sError\s)
         Else
            If (Not UsbTmc::SendData(miUsbTmc, 37, @iTransferred, sError))
               AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
               WindowLog::Error(sError\s)
            Else
               AddGadgetItem(miEditorGadgetNumber, -1, "SCPI: " + sScpi)
               AddGadgetItem(miEditorGadgetNumber, -1, "Die Daten wurden erfolgreich gesendet. iTransferred = " + iTransferred)
            EndIf
         EndIf
         If *Data
            FreeMemory(*Data)
         EndIf
      EndIf ; (Not iUsbTmc)

      DebugView::ProcOut()
   EndProcedure


   Procedure.s UsbTmcStatus(eUsbTmcStatus.i)
      DebugView::ProcIn()
      Protected sReturn.s

      Select eUsbTmcStatus
         Case UsbTmc::#eUsbTmcStatusSuccess
            sReturn = "#eUsbTmcStatusSuccess"
         Case UsbTmc::#eUsbTmcStatusPending
            sReturn = "#eUsbTmcStatusPending"
         Case UsbTmc::#eUsbTmcStatusFailed
            sReturn = "#eUsbTmcStatusFailed"
         Case UsbTmc::#eUsbTmcStatusTransferNotInProgress
            sReturn = "#eUsbTmcStatusTransferNotInProgress"
         Case UsbTmc::#eUsbTmcStatusSplitNotInProgress
            sReturn = "#eUsbTmcStatusSplitNotInProgress"
         Case UsbTmc::#eUsbTmcStatusSplitInProgress
            sReturn = "#eUsbTmcStatusSplitInProgress"
         ; USB488.
         Case UsbTmc::#eUsbTmcStatusInterruptInBusy
            sReturn = "#eUsbTmcStatusInterruptInBusy"
         Default
            sReturn = "Unbekannter USBTMC-Status!"
      EndSelect

      sReturn = " (" + sReturn + ")"

      DebugView::ProcOut()
      ProcedureReturn sReturn
   EndProcedure


   Procedure UsbTmcInitiateAbortBulkOut()
      DebugView::ProcIn()
      Protected uData.UsbTmc::uInitiateAbortBulkOutInResponse, iTag.i, sError.String

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, "Keine UsbTmc-Instanz vorhanden.")

      Else
         iTag = 37
         If (Not UsbTmc::InitiateAbortBulkOut(miUsbTmc, iTag, @uData, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)

         Else
            AddGadgetItem(miEditorGadgetNumber, -1, "Initiate Abort Bulk Out")
            AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC-Status: " + uData\eUsbTmcStatus + UsbTmcStatus(uData\eUsbTmcStatus))
            AddGadgetItem(miEditorGadgetNumber, -1, "  Tag: " + uData\iTag)
         EndIf
      EndIf ; (Not iUsbTmc)

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcCheckAbortBulkOutStatus()
      DebugView::ProcIn()
      Protected uData.UsbTmc::uCheckAbortBulkOutStatusResponse, sError.String

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, "Keine UsbTmc-Instanz vorhanden.")

      Else
         If (Not UsbTmc::CheckAbortBulkOutStatus(miUsbTmc, @uData, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)

         Else
            AddGadgetItem(miEditorGadgetNumber, -1, "Check Abort Bulk Out Status")
            AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC-Status: " + uData\eUsbTmcStatus + UsbTmcStatus(uData\eUsbTmcStatus))
            AddGadgetItem(miEditorGadgetNumber, -1, "  NBytesRxd: " + uData\iNBytesRxd)
         EndIf
      EndIf ; (Not iUsbTmc)

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcInitiateAbortBulkIn()
      DebugView::ProcIn()
      Protected uData.UsbTmc::uInitiateAbortBulkOutInResponse, iTag.i, sError.String

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, "Keine UsbTmc-Instanz vorhanden.")

      Else
         iTag = 37
         If (Not UsbTmc::InitiateAbortBulkIn(miUsbTmc, iTag, @uData, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)

         Else
            AddGadgetItem(miEditorGadgetNumber, -1, "Initiate Abort Bulk In")
            AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC-Status: " + uData\eUsbTmcStatus + UsbTmcStatus(uData\eUsbTmcStatus))
            AddGadgetItem(miEditorGadgetNumber, -1, "  Tag: " + uData\iTag)
         EndIf
      EndIf ; (Not iUsbTmc)

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcCheckAbortBulkInStatus()
      DebugView::ProcIn()
      Protected uData.UsbTmc::uCheckAbortBulkInStatusResponse, sError.String

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, "Keine UsbTmc-Instanz vorhanden.")

      Else
         If (Not UsbTmc::CheckAbortBulkInStatus(miUsbTmc, @uData, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)

         Else
            AddGadgetItem(miEditorGadgetNumber, -1, "Check Abort Bulk In Status")
            AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC-Status: " + uData\eUsbTmcStatus + UsbTmcStatus(uData\eUsbTmcStatus))
            AddGadgetItem(miEditorGadgetNumber, -1, "  AbortBulkInBitmap: " + uData\iAbortBulkInBitmap)
            AddGadgetItem(miEditorGadgetNumber, -1, "  NBytesRxd: " + uData\iNBytesRxd)
         EndIf
      EndIf ; (Not iUsbTmc)

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcInitiateClear()
      DebugView::ProcIn()
      Protected eUsbTmcStatus.i, sError.String

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, "Keine UsbTmc-Instanz vorhanden.")

      Else
         If (Not UsbTmc::InitiateClear(miUsbTmc, @eUsbTmcStatus, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)

         Else
            AddGadgetItem(miEditorGadgetNumber, -1, "Initiate Clear")
            AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC-Status: " + eUsbTmcStatus + UsbTmcStatus(eUsbTmcStatus))
         EndIf
      EndIf ; (Not iUsbTmc)

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcCheckClearStatus()
      DebugView::ProcIn()
      Protected uData.UsbTmc::uCheckClearStatusResponse, sError.String

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, "Keine UsbTmc-Instanz vorhanden.")

      Else
         If (Not UsbTmc::CheckClearStatus(miUsbTmc, @uData, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)

         Else
            AddGadgetItem(miEditorGadgetNumber, -1, "Check Clear Status")
            AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC-Status: " + uData\eUsbTmcStatus + UsbTmcStatus(uData\eUsbTmcStatus))
            AddGadgetItem(miEditorGadgetNumber, -1, "  ClearBitmap: " + uData\iClearBitmap)
         EndIf
      EndIf ; (Not iUsbTmc)

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcGetCapabilities()
      DebugView::ProcIn()
      Protected sError.String
      Protected uCapabilities.UsbTmc::uCapabilities

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, "Keine UsbTmc-Instanz vorhanden.")

      Else
         If (Not UsbTmc::GetCapabilities(miUsbTmc, @uCapabilities, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)

         Else
            With uCapabilities
               AddGadgetItem(miEditorGadgetNumber, -1,
                             "USBTMC-USB488-Capabilities")
               AddGadgetItem(miEditorGadgetNumber, -1,
                             "  USBTMC BCD Version Number: $" + Hex(\iTmcBcdVersionNumber))
               AddGadgetItem(miEditorGadgetNumber, -1,
                             "  USBTMC Interface accepts the Indicator Pulse request: " +
                             Tool::StringBool(\fTmcInterfaceAcceptsIndicatorPulseRequest))
               AddGadgetItem(miEditorGadgetNumber, -1,
                             "  USBTMC Interface is talk-only: " + StringBool(\fTmcInterfaceIsTalkOnly))
               AddGadgetItem(miEditorGadgetNumber, -1,
                             "  USBTMC Interface is listen-only: " + StringBool(\fTmcInterfaceIsListenOnly))
               AddGadgetItem(miEditorGadgetNumber, -1,
                             "  USBTMC Device supports ending TermChar: " + StringBool(\fTmcDeviceSupportsEndingTermChar))
               AddGadgetItem(miEditorGadgetNumber, -1, #Null$)
               AddGadgetItem(miEditorGadgetNumber, -1,
                             "  USB488 BCD Version Number: $" + Hex(\i488BcdVersionNumber))
               AddGadgetItem(miEditorGadgetNumber, -1,
                             "  USB488 Interface is a 488.2 USB488 Interface: " + StringBool(\f488InterfaceIs4882))
               AddGadgetItem(miEditorGadgetNumber, -1,
                             "  USB488 Interface accepts Remote/Local control: " +
                             StringBool(\f488InterfaceAcceptsRemoteLocalControlRequests))
               AddGadgetItem(miEditorGadgetNumber, -1,
                             "  USB488 Interface accepts Trigger messages: " + StringBool(\f488InterfaceAcceptsTriggerMessage))
               AddGadgetItem(miEditorGadgetNumber, -1,
                             "  USB488 Device understands all mandatory SCPI commands: " +
                             StringBool(\f488DeviceUnderstandsAllMandatoryScpiCommands))
               AddGadgetItem(miEditorGadgetNumber, -1,
                             "  USB488 Device is Service Request capable: " + StringBool(\f488DeviceIsServiceRequestCapable))
               AddGadgetItem(miEditorGadgetNumber, -1,
                             "  USB488 Device is Remote/Local capable: " + StringBool(\f488DeviceIsRemoteLocalCapable))
               AddGadgetItem(miEditorGadgetNumber, -1,
                             "  USB488 Device is Trigger capable: " + StringBool(\f488DeviceIsTriggerCapable))
            EndWith
         EndIf
      EndIf

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcIndicatorPulse()
      DebugView::ProcIn()
      Protected iData.i, sError.String

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, "Keine UsbTmc-Instanz vorhanden.")

      Else
         If (Not UsbTmc::IndicatorPulse(miUsbTmc, @iData, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)

         Else
            AddGadgetItem(miEditorGadgetNumber, -1, "Indicator Pulse")
            AddGadgetItem(miEditorGadgetNumber, -1, "  USBTMC-Status: " + iData + UsbTmcStatus(iData))
         EndIf
      EndIf ; (Not iUsbTmc)

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcReadStatusByte()
      DebugView::ProcIn()
      Protected uData.UsbTmc::uReadStatusByteResponse, sError.String
      Static iTag.i

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, "Keine UsbTmc-Instanz vorhanden.")

      Else
         iTag + 1
         If ((iTag < 2) Or (iTag > 127))
            iTag = 2
         EndIf

         If (Not UsbTmc::ReadStatusByte(miUsbTmc, iTag, @uData, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)

         Else
            AddGadgetItem(miEditorGadgetNumber, -1, "Read Status Byte")
            AddGadgetItem(miEditorGadgetNumber, -1,
                          "  eUsbTmcStatus: " + uData\eUsbTmcStatus + UsbTmcStatus(uData\eUsbTmcStatus))
            AddGadgetItem(miEditorGadgetNumber, -1,
                          "  iTag: " + uData\iTag + " - gesendet: " + iTag + " mit Bit 7 gesetzt: " + Str(iTag | $80))
            AddGadgetItem(miEditorGadgetNumber, -1, "  iStatusByte: " + uData\iStatusByte +
                                                    " - %" + Bin(uData\iStatusByte, #PB_Byte))
            AddGadgetItem(miEditorGadgetNumber, -1,
                          "Wenn das Gerät einen Interrupt-In Endpoint hat, wird damit das Statusbyte übertragen.")
            AddGadgetItem(miEditorGadgetNumber, -1, "Das Statusbyte ist dann hier immer Null.")
         EndIf
      EndIf ; (Not iUsbTmc)

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcInterruptTransfer()
      DebugView::ProcIn()
      Protected uData.UsbTmc::uInterruptTransferResponse, sError.String
      
      ClearGadgetItems(miEditorGadgetNumber)
      
      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, "Keine UsbTmc-Instanz vorhanden.")
         
      Else
         If (Not UsbTmc::InterruptTransfer(miUsbTmc, @uData, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)
            
         Else
            AddGadgetItem(miEditorGadgetNumber, -1, "Interrupt Transfer")
            AddGadgetItem(miEditorGadgetNumber, -1, "  iNotify1: " + uData\iNotify1)
            AddGadgetItem(miEditorGadgetNumber, -1, "  iNotify2: " + uData\iNotify2)
            AddGadgetItem(miEditorGadgetNumber, -1, #Null$)
            AddGadgetItem(miEditorGadgetNumber, -1, "Bedeutung für Read Status Byte")
            AddGadgetItem(miEditorGadgetNumber, -1,
                          "  iNotify1 ist das gesendete iTag, nur mit Bit 7 gesetzt: " + uData\iNotify1 +
                          " - gesendet: " + Str(uData\iNotify1 ! $80))
            AddGadgetItem(miEditorGadgetNumber, -1, "  iNotify2 ist das iStatusByte: " + uData\iNotify2 +
                                                    " - %" + Bin(uData\iNotify2, #PB_Byte))
            AddGadgetItem(miEditorGadgetNumber, -1, #Null$)
            AddGadgetItem(miEditorGadgetNumber, -1, "Bedeutung für Service Request")
            AddGadgetItem(miEditorGadgetNumber, -1, "  iNotify1 muss immer 129 sein: " + uData\iNotify1)
            AddGadgetItem(miEditorGadgetNumber, -1, "  iNotify2 ist das iStatusByte: " + uData\iNotify2 +
                                                    " - %" + Bin(uData\iNotify2, #PB_Byte))
         EndIf
      EndIf ; (Not iUsbTmc)
            ;       EndIf
      
      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcRemoteEnableControl()
      DebugView::ProcIn()
      Protected eUsbTmcStatus.i, sError.String
      Static fRemoteEnableControl.i

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, "Keine UsbTmc-Instanz vorhanden.")

      Else
         fRemoteEnableControl = Bool(Not fRemoteEnableControl)
         If (Not UsbTmc::RemoteEnableControl(miUsbTmc, fRemoteEnableControl, @eUsbTmcStatus, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)

         Else
            AddGadgetItem(miEditorGadgetNumber, -1, "REN Control - aktiviert: " + StringBool(fRemoteEnableControl))
            AddGadgetItem(miEditorGadgetNumber, -1, "  eUsbTmcStatus: " + eUsbTmcStatus + UsbTmcStatus(eUsbTmcStatus))
         EndIf
      EndIf ; (Not iUsbTmc)

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcLocalLockout()
      DebugView::ProcIn()
      Protected eUsbTmcStatus.i, sError.String

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, "Keine UsbTmc-Instanz vorhanden.")

      Else
         If (Not UsbTmc::LocalLockout(miUsbTmc, @eUsbTmcStatus, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)

         Else
            AddGadgetItem(miEditorGadgetNumber, -1, "Local Lockout")
            AddGadgetItem(miEditorGadgetNumber, -1, "  eUsbTmcStatus: " + eUsbTmcStatus + UsbTmcStatus(eUsbTmcStatus))
         EndIf
      EndIf ; (Not iUsbTmc)

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcGoToLocal()
      DebugView::ProcIn()
      Protected eUsbTmcStatus.i, sError.String

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not miUsbTmc)
         AddGadgetItem(miEditorGadgetNumber, -1, "Keine UsbTmc-Instanz vorhanden.")

      Else
         If (Not UsbTmc::GoToLocal(miUsbTmc, @eUsbTmcStatus, sError))
            AddGadgetItem(miEditorGadgetNumber, -1, sError\s)

         Else
            AddGadgetItem(miEditorGadgetNumber, -1, "Go To Local")
            AddGadgetItem(miEditorGadgetNumber, -1, "  eUsbTmcStatus: " + eUsbTmcStatus + UsbTmcStatus(eUsbTmcStatus))
         EndIf
      EndIf ; (Not iUsbTmc)

      DebugView::ProcOut()
   EndProcedure


   Procedure UsbTmcDeleteInstance()
      DebugView::ProcIn()
      Protected sError.String

      ClearGadgetItems(miEditorGadgetNumber)

      If (Not UsbTmc::DeleteInstance(miUsbTmc, sError))
         AddGadgetItem(miEditorGadgetNumber, -1, sError\s)

      Else
         AddGadgetItem(miEditorGadgetNumber, -1, "UsbTmc-Instanz gelöscht: " + miUsbTmc)
         miUsbTmc = #Null
      EndIf

      DebugView::ProcOut()
   EndProcedure

   ;-

   Procedure.i Open()
      ; Das Programmfenster laden und anzeigen.
      DebugView::ProcIn()
      Protected fResult.i, fError.i, iFontNumber.i
      Protected sXml.s

      sXml = "<window id='" + #eWindow + "' name='WindowStart' text='" + #sWindowTitle + "' " +
             "minwidth='" + #iWindowMinWidth + "' minheight='" + #iWindowMinHeight + "' " +
             "flags='#PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget | #PB_Window_SizeGadget'>" +
             " <vbox expand='yes'>" +
             "    <splitter id='" + #eSplitter + "' firstmin='auto' secondmin='auto'>" +
             "       <listview id='" + #eListView + "'/>" +
             "       <singlebox expand='yes' margin='bottom:" + MenuHeight() + "'>" +
             "          <editor id='" + #eEditor + "'/>" +
             "       </singlebox>" +
             "    </splitter>" +
             " </vbox>" +
             "</window>"

      miWindowDialogNumber = CreateDialog(#PB_Any)
      If (Not miWindowDialogNumber)
         fError = #True
         DebugView::Error("Das XML-Dialog für das Fenster >" + #PB_Compiler_Module + "< konnte nicht erstellt werden.")

      Else
         miWindowXmlNumber = CatchXML(#PB_Any, @sXml, StringByteLength(sXml), #Null, #PB_Unicode)
         If (Not miWindowXmlNumber)
            fError = #True
            DebugView::Error("Die XML-Daten konnten nicht gelesen werden.")

         Else
            If Not (XMLStatus(miWindowXmlNumber) = #PB_XML_Success)
               fError = #True
               DebugView::Error("Beim Parsen der XML-Daten ist ein Fehler aufgetreten.")
               DebugView::Error(XMLError(miWindowXmlNumber))
            EndIf
         EndIf
      EndIf

      If (Not fError)
         fResult = OpenXMLDialog(miWindowDialogNumber, miWindowXmlNumber, "WindowStart",
                                 #PB_Ignore, #PB_Ignore , #iWindowWidth, #iWindowHeight)
         If (Not fResult)
            fError = #True
            DebugView::Error("Der XML-Dialog konnte nicht geöffnet werden.")
            DebugView::Error(DialogError(miWindowDialogNumber))

         Else
            miWindowNumber = #eWindow
            FreeXML(miWindowXmlNumber)
         EndIf
      EndIf

      If fError
         PostEvent(#eCustomEventExitApplication)
      EndIf

      If (Not fError)

         BindEvent(#PB_Event_CloseWindow, @EventCloseWindow(), miWindowNumber)
         BindEvent(#PB_Event_MinimizeWindow, @EventMinimizeWindow(), miWindowNumber)
         BindEvent(#PB_Event_RestoreWindow, @EventRestoreWindow(), miWindowNumber)

         Tool::WindowReduceFlicker(miWindowNumber)

         miMenuNumber = CreateMenu(#PB_Any, WindowID(miWindowNumber))
         If miMenuNumber
            MenuTitle(#sMenuTitleFile)
            MenuItem(#eMenuItemFileExit, #sMenuItemFileExit)
            MenuTitle(#sMenuTitleEdit)
            MenuTitle(#sMenuTitleHelp)
            MenuItem(#eMenuItemHelpLog, #sMenuItemHelpLog)
            MenuItem(#eMenuItemHelpAbout, #sMenuItemHelpAbout)

            BindMenuEvent(miMenuNumber, #eMenuItemFileExit, @EventMenuFileExit())
            BindMenuEvent(miMenuNumber, #eMenuItemHelpLog, @EventMenuHelpLog())
            BindMenuEvent(miMenuNumber, #eMenuItemHelpAbout, @EventMenuHelpAbout())
         EndIf

         iFontNumber = LoadFont(#PB_Any, #sFontName, #iFontSize)

         miListViewGadgetNumber = #eListView
         SetGadgetFont(miListViewGadgetNumber, FontID(iFontNumber))

         ;- Listeneinträge.
         AddGadgetItem(miListViewGadgetNumber, -1,
                       "LibUsb-Version - LibUsb::GetVersion()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewGetVersion)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "Alle verfügbaren USBTMC-Geräte auflisten - UsbTmc::GetTmcDeviceList() mit SetTmcDevice(), GetCapabilities()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcGetDeviceList)

         AddGadgetItem(miListViewGadgetNumber, -1, #Null$)
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewEmpty)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "UsbTmc-Instanz erstellen mit Context - UsbTmc::NewInstance(Context)")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcOwnContext)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "Test für Rigol Bildschirmkopie - Fenster mehrmals öffnen.")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewRigolScreencopy)

         AddGadgetItem(miListViewGadgetNumber, -1, #Null$)
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewEmpty)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "Neue UsbTmc-Instanz erstellen - UsbTmc::NewInstance()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcNewInstance)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "Erstes UsbTmc-Gerät verwenden - UsbTmc::SetTmcDevice()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcSetTmcDevice)

         AddGadgetItem(miListViewGadgetNumber, -1, #Null$)
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewEmpty)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "SCPI-Komando senden ':ROUTe:OPEN:ALL' - UsbTmc::SendData() und PrepareData()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcSendData)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "SCPI-Komando senden und empfangen '*IDN?' - UsbTmc::SendData() und RequestData()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcRequestData)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "SCPI-Komando senden und empfangen per Thread '*IDN?' - UsbTmc::SendRequestThreadData()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcSendRequestThreadData)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "SCPI-Komando senden '*SRE 16' (MAV-Bit) - UsbTmc::SendData() und PrepareData()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcSendDataSRE16)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "SCPI-Komando senden '*SRE 0' (MAV-Bit) - UsbTmc::SendData() und PrepareData()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcSendDataSRE0)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "SCPI-Komando senden und empfangen per Thread '*IDN?' - UsbTmc::SendRequestThreadData(fWaitSRE=#True)")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcSendWaitRequestThreadData)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "SCPI-Komando senden '*IDN?' - UsbTmc::SendData() und PrepareData()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcSendDataIDN)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "SCPI-Komando empfangen - UsbTmc::RequestData()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcRequestDataOnly)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "SCPI-Komando senden und empfangen per Thread ':SYST:UTIL:READ? 1,10000000' - UsbTmc::SendRequestThreadData()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcSendRequestThreadDataMemoryDump)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "SCPI-Komando senden - Vendor Specific ':TEST:MAXCURR' - UsbTmc::SendData() und PrepareData()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcSendDataVendorSpecific)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "SCPI-Komando senden und empfangen - Vendor Specific ':SETUP:MANU?' - UsbTmc::SendData() und RequestData()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcSendRequestDataVendorSpecific)
 
         AddGadgetItem(miListViewGadgetNumber, -1,
                       "SCPI-Komando senden - mit ungültiger Message-ID ':ROUTe:OPEN:ALL' - UsbTmc::SendData() und PrepareData()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcSendDataError)

         AddGadgetItem(miListViewGadgetNumber, -1, #Null$)
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewEmpty)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "USBTMC Initiate Abort Bulk Out - UsbTmc::InitiateAbortBulkOut()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcInitiateAbortBulkOut)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "USBTMC Check Abort Bulk Out Status - UsbTmc::CheckAbortBulkOutStatus()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcCheckAbortBulkOutStatus)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "USBTMC Initiate Abort Bulk In - UsbTmc::InitiateAbortBulkIn()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcInitiateAbortBulkIn)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "USBTMC Check Abort Bulk In Status - UsbTmc::CheckAbortBulkInStatus()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcCheckAbortBulkInStatus)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "USBTMC Initiate Clear - UsbTmc::InitiateClear()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcInitiateClear)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "USBTMC Check Clear Status - UsbTmc::CheckClearStatus()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcCheckClearStatus)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "USBTMC Get Capabilities - UsbTmc::GetCapabilities()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcGetCapabilities)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "USBTMC Indicator Pulse - UsbTmc::IndicatorPulse()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcIndicatorPulse)

         AddGadgetItem(miListViewGadgetNumber, -1, #Null$)
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewEmpty)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "USB488 Read Status Byte - UsbTmc::ReadStatusByte()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcReadStatusByte)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "USB488 Interrupt Transfer - UsbTmc::InterruptTransfer()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcInterruptTransfer)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "USB488 REN Control aktivieren/deaktivieren - UsbTmc::RemoteEnableControl()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcRemoteEnableControl)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "USB488 Local Lockout - UsbTmc::LocalLockout()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcLocalLockout)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "USB488 Go To Local - UsbTmc::GoToLocal()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcGoToLocal)

         AddGadgetItem(miListViewGadgetNumber, -1, #Null$)
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewEmpty)

         AddGadgetItem(miListViewGadgetNumber, -1,
                       "Die UsbTmc-Instanz löschen - UsbTmc::DeleteInstance()")
         SetGadgetItemData(miListViewGadgetNumber, CountGadgetItems(miListViewGadgetNumber) - 1, #iListViewUsbTmcDeleteInstance)

         BindGadgetEvent(miListViewGadgetNumber, @EventListViewGadgetLeftClick(), #PB_EventType_LeftClick)

         miEditorGadgetNumber = #eEditor

         miSplitterGadgetNumber = #eSplitter
         SetGadgetFont(miEditorGadgetNumber, FontID(iFontNumber))
         SetGadgetState(miSplitterGadgetNumber, 150)

         PostEvent(#PB_Event_SizeWindow, miWindowNumber, #Null)
      EndIf

      DebugView::ProcOut()
      ProcedureReturn miWindowNumber
   EndProcedure


   Procedure Close()
      ; Schließt das Fenster und Programm.
      DebugView::ProcIn()
      Protected iWindowNumber.i, sError.String

      If miWindowNumber

         If miUsbTmc
            UsbTmc::DeleteInstance(miUsbTmc, sError)
         EndIf

         UnbindEvent(#PB_Event_CloseWindow, @EventCloseWindow(), miWindowNumber)
         UnbindEvent(#PB_Event_MinimizeWindow, @EventMinimizeWindow(), miWindowNumber)
         UnbindEvent(#PB_Event_RestoreWindow, @EventRestoreWindow(), miWindowNumber)

         UnbindMenuEvent(miMenuNumber, #eMenuItemFileExit, @EventMenuFileExit())
         UnbindMenuEvent(miMenuNumber, #eMenuItemHelpLog, @EventMenuHelpLog())
         UnbindMenuEvent(miMenuNumber, #eMenuItemHelpAbout, @EventMenuHelpAbout())

         UnbindGadgetEvent(miListViewGadgetNumber, @EventListViewGadgetLeftClick(), #PB_EventType_LeftClick)
         
         ; Geöffnete Fenster schließen.
         ForEach mWindowScreencopyList()
            iWindowNumber = mWindowScreencopyList()
            If iWindowNumber
               If (IsWindow(iWindowNumber) And (iWindowNumber <> miWindowNumber))
                  SendMessage_(WindowID(iWindowNumber), #WM_CLOSE, #Null, #Null)
               EndIf
            EndIf
         Next
         FreeList(mWindowScreencopyList())
         
         FreeDialog(miWindowDialogNumber)
         miWindowNumber = #Null
         
         ; Ereignis für das Beenden des Programms an die Hauptschleife senden.
         PostEvent(#eCustomEventExitApplication)

      EndIf

      DebugView::ProcOut()
      ProcedureReturn
   EndProcedure


EndModule   ; WindowStartXml.
